Index: channels/chan_sip.c
===================================================================
--- channels/chan_sip.c	(revision 214934)
+++ channels/chan_sip.c	(working copy)
@@ -18611,6 +18611,31 @@
 		}
 	}
 
+	if (p->owner) {
+		bridged_to = ast_bridged_channel(p->owner);
+		if (bridged_to) {
+			const char *srbh = pbx_builtin_getvar_helper(bridged_to, "SIPREMOTEBYEHEADER");
+			if (!ast_strlen_zero(srbh)) {
+				char workspace[1024], request[128];
+				char *varname;
+				char *header = ast_strdup(srbh);
+				if ( (varname = strchr(header, ',')) ) {
+					*varname = '\0';
+					varname++;
+					snprintf(request, sizeof(request), "SIP_HEADER(%s)", header);
+					ast_func_read(p->owner, request, workspace, sizeof(workspace));
+					ast_log(LOG_DEBUG, "Requested header '%s' contain '%s'\n", header, workspace);
+					if (!ast_strlen_zero(varname)) {
+						pbx_builtin_setvar_helper(bridged_to, varname, workspace);
+						ast_log(LOG_DEBUG, "Setting var '%s' to '%s'\n", varname, workspace);
+					}
+				} else {
+					ast_log(LOG_DEBUG, "SIPREMOTEBYEHEADER ('%s') is malformed\n", srbh);
+				}
+			}
+		}
+	}
+
 	stop_media_flows(p); /* Immediately stop RTP, VRTP and UDPTL as applicable */
 	stop_session_timer(p); /* Stop Session-Timer */
 
